您的位置:首页 > 其它

HDU 2639 Bone Collector II [动态规划 第k大01背包]

2016-08-01 20:53 489 查看

题干

Problem Description

The title of this problem is familiar,isn’t it?yeah,if you had took part in the “Rookie Cup” competition,you must have seem this title.If you haven’t seen it before,it doesn’t matter,I will give you a link:

Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.

Input

The first line contain a integer T , the number of cases.

Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.

Output

One integer per line representing the K-th maximum of the total value (this number will be less than 231).

Sample Input

3

5 10 2

1 2 3 4 5

5 4 3 2 1

5 10 12

1 2 3 4 5

5 4 3 2 1

5 10 16

1 2 3 4 5

5 4 3 2 1

Sample Output

12

2

0

题解

/**
*求第K大的背包,要保证是严格递减的
*技巧:加一维数组保存第K大,合并的时候,发现两个
*数组即(dp[j][1...K]和dp[j-vol[i]][1...K] + val[i])都是递减的,
*所以O(n)时间内就可以完成dp[j][1...K]数组的更新
*转移方程:dp[j][t]表示体积为j时,第k大的背包的最优值(1<=t<=K)
*dp[j][1...K] = max(dp[j][1...K], dp[j-vol[i]][1...K] + val[i])(其中i表示第i个物品)
*/
#include<cstdio>
#include<cstring>

using namespace std;

const int inf = 0x3f3f3f3f;
int dp[1010][70];
int main(){
//freopen("in.txt","r",stdin);
int T,N,V,K;
int tmp[70];
int val[110];
int vol[110];
scanf("%d",&T);
while(T--){
scanf("%d%d%d",&N,&V,&K);
for(int i=1;i<=N;i++)scanf("%d",&val[i]);
for(int i=1;i<=N;i++)scanf("%d",&vol[i]);
memset(dp, 0, sizeof(dp));
for(int i=2;i<70;i++)dp[0][i] = -inf;//赋值为-inf,表示该位置保存的数据无效
for(int j=0;j<=V;j++)for(int i=K+1;i<70;i++)dp[j][i] = -inf;//赋值为-inf,表示该位置保存的数据无效,
//以此保证合并两个数组时更方便
for(int i=1; i<=N; i++){
for(int j=V; j>=vol[i]; j--){
int l = 1, r = 1, t = 1;
//初始化tmp数组,初始为-inf,防止因为重复的价值使得合并时不能给后面的位置赋值
memset(tmp,-inf,sizeof(tmp));
//将值合并到tmp中
while(t <= K){
if(dp[j][l] > dp[j-vol[i]][r] + val[i]){
tmp[t] = dp[j][l++];
}else{
tmp[t] = dp[j-vol[i]][r++] + val[i];
}
if(tmp[t]!=tmp[t-1])t++;
if(l > K && r > K)break;
}
//将tmp的数据更新到dp数组
for(int i=1;i<=K;i++)dp[j][i] = tmp[i];
}
}
if(dp[V][K]<0)printf("0\n");
else printf("%d\n",dp[V][K]);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  动态规划